/**
* @file cloud_effect.h
*/

#ifndef _CLOUD_EFFECT
#define _CLOUD_EFFECT

#include "weather_effect.h"

#include "sound_buffer.h"
#include "sound_source.h"

#include "world_entity.h"
#include "glincl.h"

class Material;
class Vector;

class CloudEffect : public WeatherEffect
{
	public:
		CloudEffect(const TiXmlElement* root = NULL);
		virtual ~CloudEffect();

		virtual void loadParams(const TiXmlElement* root);

		virtual bool init();

		virtual bool activate();
		virtual bool deactivate();

		virtual void draw() const;
		virtual void tick(float dt);

		void setRadius(float radius);
		void setTexture(char* fileName);


	private:
		void initialize(char* fileName);

		GLUquadricObj*			sphereObj;		// A Placeholder for the Sphere.
		Material*			cloudMaterial;		// A Material for the Sphere.
		float				sphereRadius;		// Radius of the Sphere.

		float 				mover;
		float				cloudSpeed;
		std::string			cloudTexture;

		inline void setCloudTexture(const std::string& file) { this->cloudTexture = file; }
		inline void setCloudAnimation(float speed) { this->cloudSpeed = speed; }

};

#endif  /* _CLOUD_EFFECT */
